package org.communiquons.dccaggregator.models

import dgca.verifier.app.decoder.CertificateDecodingResult
import dgca.verifier.app.decoder.DefaultCertificateDecoder
import dgca.verifier.app.decoder.base45.Base45Decoder
import dgca.verifier.app.decoder.model.GreenCertificate

@OptIn(ExperimentalUnsignedTypes::class)
class Certificate(val encoded: String) {

    // Decoded green certificate
    val decoded: GreenCertificate;

    init {
        val res = DefaultCertificateDecoder(Base45Decoder()).decodeCertificate(encoded)

        if (res is CertificateDecodingResult.Error)
            throw Exception("Failed to read certificate!", res.error.error)

        decoded = (res as CertificateDecodingResult.Success).greenCertificate
    }

    /**
     * Get person full name
     */
    val fullName get() = "${decoded.person.standardisedGivenName} ${decoded.person.standardisedFamilyName}"
}